# Introduction
This project is a possible solution to the realtime protocol exercise.

Three programs are provided: one server, written in Go, and two clients written in NodeJS. One client is stateless while the other one is stateful (see more details about this in the corresponding brief).

# Requirements:
The requirements for this project are as follows:
* Go 1.12 or newer
* NodeJS 8.10.0 or newer
* NPM

This project as been tested on Ubuntu 18.04.

# Dependencies
All dependencies are automatically fetched using either the Go module system, or NPM.

## Server
* gRPC for Go
* go-flags

## Client
* gRPC for NodeJS
* Minimist
* node-crc
* uuid

# Setup
A few steps are required to be able to run this project.

## Fetching dependencies and compiling the server
```sh
go build
```

## Fetching dependencies for the clients
```sh
npm install
```

# Running
The server and the clients have to be run on the same computer.

## Server
The server requires a port parameter.
```sh
./server -p5000
```
A network error can also be simulated during each transmission by passing the -s parameter.

## Clients
Both clients, the stateless and the stateful one, also require a port parameter. The stateless client also requires a maximum number sequence size.
```sh
node statelessClient.js -p5000 -n3
```
```sh
node statefulClient.js -p5000
```

The stateful client can use a provided UUID and number intead of generating them (used for testing purposes).
```sh
node statefulClient.js -p5000 --uuid=d2d5d7be-31b6-46b7-a2fd-3a4256ac972b -n42
```

# Testing
A basic functional test script is provided. It can be run like this:
```sh
./tests.sh
```

# Protocol
The server and the clients communicate through gRPC. The Go generated code for the gRPC proto file can be generated by this command: (the Protobuf generator has to be installed)
```sh
./generate-proto.sh
```

## Limits
Number sizes and signedness within protocol messages can be read using the numbers/numbers.proto file. Both the client and the server should be endianess aware.

There are however some limits to this protocol. The fact that, in the stateless case, the client and server communicate through 32 bit integers limits the maximal value to 2147483647. It is asumed here that the client will cancel the stream before it reached this value. In the stateful case, the number is send using a unsigned 32 bit integer, so the limit is 4294967295.

## Stateless client
In the case of the stateless client, the client sends a first message containing the latest received number, or 0 if there is none. This allows the server to continue sending the number sequence even if the connection breaks and the client reconnects.

### Completion
The client knows when the stream is complete because it decides when to end it by cancelling the gRPC stream.

### Connection drop
The client resumes from a dropped connection by starting the stream again while sending the latest received number.

## Stateful client
In the case of the stateful client, the client sends a first message containing the UUID and a random number that will be used by the server as a seed for the pseudo random number generation.

### Completion
The client knows when the stream is complete because the server ends the stream (after sending 3 numbers without any error, if an error occurs it send 3 numbers again when/if the client reconnected within 30 seconds).

### Connection drop
The client resumes from a dropped connection by starting the stream again whith the same parameters. It has to do so during the next 30 seconds (time counting from the latest message sent), otherwise the state is lost and the client will receive a "DeadlineExceeded" error.

### Validation
The client can validate the result by comparing the checksum sent with the latest message to the checksum it has itself computed (see the checksum computation algorithm below).

### Random number generation
The server uses the pseudo random number generation provided by Go: https://golang.org/pkg/math/rand/

It uses one generator per session state, and uses the client-provided number as a seed, so that if the same client disconnects and later reconnects the same number sequence is generated.

### Reconnection parameters
In the case of a reconnection, the client sends the same UUID and number it has generated before. The server then resumes sending the number sequence (see the above explanation).

### Stored session state
The stored session state includes:
* The last update time, which is required to prune session states older than 30 seconds. This last update time is set to the current time with every sent number.
* A random generator, so that every time the same client connects it gets the same sequence of numbers.
* The current checkum, which is computed each time a number is sent, and stored in the session so that it persists in the case of client disconnections. The checksum has to be the same at the end of the number sequence, so storing it in required.
* An optional "simulated disconnection" boolean, which is only used to send a fake error when testing the server. This is not part of the regular state and could be removed.

### Checksum
Checksum computation is done using the CRC32 algorithm using the IEEE polynomial. The session checksum is updated with each sent number by computing the checksum of the number itself and the current checksum. Both are considered as big endian 32 bit integers.
